#ifndef __DATABASE_H__
#define __DATABASE_H__

#include <iostream>
#include <sstream>
#include <string>
#include <vector>
#include <sqlite3.h>


using namespace std;

class Database{

private:
	sqlite3 *database;

	class QueryStream : public std::ostream {
	private:
		class QueryBuf : public std::stringbuf {
		private:
			Database *m_db;
		public:
		    QueryBuf(Database *db) { m_db = db;}
		    ~QueryBuf() {  pubsync(); }
		    int sync() {
		        m_db->result = m_db->query2(str());
		        str("");
		        return 0;
		    }
		};

	public:
		QueryStream(Database *db) : std::ostream(new QueryBuf(db)) {}
		~QueryStream() { delete rdbuf(); }
	};

public:
	bool open(string filename);
    vector<vector<string> > query2(string query);
	void close();

    vector<vector<string> > result;
	QueryStream query;

	Database(const std::string& filename) : query(this) {
		database = NULL;
		open(filename);
	};
	~Database(){}
};

#endif

