#include <sstream>
#include <iostream>
#include <regex>
#include <string>
#include <getopt.h>
#include "Manager.h"

#define no_argument 0
#define required_argument 1
#define optional_argument 2

using namespace std;

constexpr unsigned int arg(const char* str, int h = 0) {
    return !str[h] ? 5381 : (arg(str, h + 1) * 33) ^ str[h];
}

int main(int argc, char *argv[]) {
    int opt, index;
    string file = "passwd.db";

    const struct option longopts[] = { { "version", no_argument, 0, 'v' }, {
            "help", no_argument, 0, 'h' }, { "reverse", no_argument, 0, 'r' }, {
            "permanent", no_argument, 0, 's' }, { "debug", optional_argument, 0,
            'd' }, { "password", required_argument, 0, 'p' }, { "user",
            required_argument, 0, 'u' }, { "interface", required_argument, 0,
            'i' }, { "header", required_argument, 0, 'b' }, { "hex",
            required_argument, 0, 'x' }, { "file", required_argument, 0, 'f' },
            { "timeout", required_argument, 0, 't' }, { "wait",
                    required_argument, 0, 'w' }, { 0, 0, 0, 0 }, };

    while ((opt = getopt_long(argc, argv, "bhrvswxp:u:i:f:t:d::", longopts,
            &index)) != -1) {
        switch (opt) {

        /*case 'h':
         fprintf(stderr, VERSION);
         fprintf(stderr, USAGE, argv[0]);
         fprintf(stderr, HELP);
         exit(EXIT_SUCCESS);
         break;

         case 'v':
         fprintf(stderr, VERSION);
         exit(EXIT_SUCCESS);
         break;*/

        case 'r':
            //options.flags |= FLAG_REVERSE;
            break;

        case 'd':
            //options.flags |= FLAG_DEBUG;
            //if (optarg != NULL)
            //  options.debug_level = atoi(optarg);
            break;

        case 't':
            //options.timeout = atol(optarg);
            break;

        case 'f':
            file = std::string(optarg);
            break;

        default: /* '?' */
            //cerr << "Unknown option" << endl;
            //cerr << argv[0] << " <account identifier>" << endl;
            exit (EXIT_FAILURE);
        }
    }

    Manager mg(file);

    switch (argc - optind) {
    case 0:
        mg.show();
        break;

    case 1:
        if (!strcmp(argv[optind], "clear")) {
            mg.clear();
            cerr << file << " cleared" << endl;
        } else {
            mg.get(argv[optind]);
        }
        break;
    case 2:
        if (!strcmp(argv[optind], "new")) {
            mg.create(argv[optind+1]);
        }
        break;
    case 3:
        if (!strcmp(argv[optind], "add")) {
            mg.add(argv[optind+1], argv[optind+2]);
        } else {
            cerr << argv[0] << " <account identifier>" << endl;
        }
        break;
    }
    exit (EXIT_SUCCESS);
}

